<?xml version="1.0" encoding="UTF-8"?>
<GestureMarkupLanguage xmlns:gml="http://gestureworks.com/gml/version/1.0">
	
	<Gesture_set gesture_set_name="n-manipulate" >
		
			<Gesture id="n-drag" type="drag">
				<comment>The 'n-drag' gesture can be activated by any number of touch points. When a touch down is recognized on a touch object the position
				of the touch point is tracked. This change in the position of the touch point is mapped directly to the position of the touch object.</comment>
				<match>
					<action>
						<initial>
							<cluster point_number="0" point_number_min="1" point_number_max="5" translation_threshold="0"/>
						</initial>
					</action>
				</match>	
				<analysis>
					<algorithm>
						<library module="translate"/>
						<returns>
							<property id="drag_dx"/>
							<property id="drag_dy"/>
						</returns>
					</algorithm>
				</analysis>	
				<processing>
					<inertial_filter>
						<property ref="drag_dx" release_inertia="false" friction="0.996"/>
						<property ref="drag_dy" release_inertia="false" friction="0.996"/>
					</inertial_filter>
				</processing>
				<mapping>
					<update>
						<gesture_event>
							<property ref="drag_dx" target="x" delta_threshold="true" delta_min="0.01" delta_max="100"/>
							<property ref="drag_dy" target="y" delta_threshold="true" delta_min="0.01" delta_max="100"/>
						</gesture_event>
					</update>
				</mapping>
			</Gesture>
			
			<Gesture id="n-rotate" type="rotate">
				<match>
					<action>
						<initial>
							<cluster point_number="0" point_number_min="2" point_number_max="5" rotatation_threshold="0"/>
						</initial>
					</action>
				</match>
				<analysis>
					<algorithm>
						<library module="rotate"/>
						<returns>
							<property id="rotate_dtheta"/>
						</returns>
					</algorithm>
				</analysis>	
				<processing>
					<noise_filter>
						<property ref="rotate_dtheta"  noise_filter="false" percent="30"/>
					</noise_filter>
					<inertial_filter>
						<property ref="rotate_dtheta" release_inertia="false" friction="0.996"/>
					</inertial_filter>
				</processing>
				<mapping>
					<update>
						<gesture_event>
							<property ref="rotate_dtheta" target="rotate" delta_threshold="true" delta_min="0.1" delta_max="10"/>
						</gesture_event>
					</update>
				</mapping>
			</Gesture>
			
			<Gesture id="n-scale" type="scale">
				<match>
					<action>
						<initial>
							<cluster point_number="0" point_number_min="2" point_number_max="5" separation_threshold="0"/>
						</initial>
					</action>
				</match>
				<analysis>
					<algorithm>
						<library module="scale"/>
						<returns>
							<property id="scale_dsx"/>
							<property id="scale_dsy"/>
						</returns>
					</algorithm>
				</analysis>	
				<processing>
					<inertial_filter>
						<property ref="scale_dsx" release_inertia="false" friction="0.996"/>
						<property ref="scale_dsy" release_inertia="false" friction="0.996"/>
					</inertial_filter>
				</processing>
				<mapping>
					<update>
						<gesture_event>
							<property ref="scale_dsx" target="scaleX" func="linear" factor="0.0018" delta_threshold="false" delta_min="0.0001" delta_max="1"/>
							<property ref="scale_dsy" target="scaleY" func="linear" factor="0.0018" delta_threshold="false" delta_min="0.0001" delta_max="1"/>
						</gesture_event>
					</update>
				</mapping>
			</Gesture>
			
		</Gesture_set>
	
</GestureMarkupLanguage>